<?php
// @(#) $Id: Textile.php,v 1.5 2005/03/21 15:33:01 jhriggs Exp $

/* This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

class Textile {
  var $options = array();
  var $urlre;
  var $punct;
  var $valignre;
  var $tblalignre;
  var $halignre;
  var $alignre;
  var $imgalignre;
  var $clstypadre;
  var $clstyre;
  var $clstyfiltre;
  var $codere;
  var $blocktags;
  var $links = array();
  var $repl = array();
  var $tmp = array();
  function Textile($options = array()) {
    $this->options = $options;
    $this->options['filters'] = ($this->options['filters'] ? $this->options['filters'] : array());
    $this->options['charset'] = ($this->options['charset'] ? $this->options['charset'] : 'iso-8859-1');
    $this->options['char_encoding'] = (isset($this->options['char_encoding']) ? $this->options['char_encoding'] : 1);
    $this->options['do_quotes'] = (isset($this->options['do_quotes']) ? $this->options['do_quotes'] : 1);
    $this->options['trim_spaces'] = (isset($this->options['trim_spaces']) ? $this->options['trim_spaces'] : 0);
    $this->options['smarty_mode'] = (isset($this->options['smarty_mode']) ? $this->options['smarty_mode'] : 1);
    $this->options['preserve_spaces'] = (isset($this->options['preserve_spaces']) ? $this->options['preserve_spaaces'] : 0);
    $this->options['head_offset'] = (isset($this->options['head_offset']) ? $this->options['head_offset'] : 0);

    if (is_array($this->options['css'])) {
      $this->css($this->options['css']);
    }
    $this->options['macros'] = ($this->options['macros'] ? $this->options['macros'] : $this->default_macros());
    if (isset($this->options['flavor'])) {
      $this->flavor($this->options['flavor']);
    } else {
      $this->flavor('xhtml1/css');
    }
    $this->_create_re();
  }
function set($opt, $value = NULL) {
    if (is_array($opt)) {
      foreach ($opt as $opt => $value) {
        $this->set($opt, $value);
      }
    } else {
      if ($opt == 'charset') {
        $this->charset($value);
      } elseif ($opt == 'css') {
        $this->css($value);
      } elseif ($opt == 'flavor') {
        $this->flavor($value);
      } else {
        $this->options[$opt] = $value;
      }
    }
  }
function get($opt) {
    return $this->options[$opt];
  }
function disable_html($disable_html = NULL) {
    if ($disable_html != NULL) {
      $this->options['disable_html'] = $disable_html;
    }
    return ($this->options['disable_html'] ? $this->options['disable_html'] : 0);
  }
  function head_offset($head_offset = NULL) {
    if ($head_offset != NULL) {
      $this->options['head_offset'] = $head_offset;
    }
    return ($this->options['head_offset'] ? $this->options['head_offset'] : 0);
  }
function flavor($flavor = NULL) {
    if ($flavor != NULL) {
      $this->options['flavor'] = $flavor;
      if (preg_match('/^xhtml(\d)?(\D|$)/', $flavor, $matches)) {
        if ($matches[1] == '2') {
          $this->options['_line_open'] = '<l>';
          $this->options['_line_close'] = '</l>';
          $this->options['_blockcode_open'] = '<blockcode>';
          $this->options['_blockcode_close'] = '</blockcode>';
          $this->options['css_mode'] = 1;
        } else {
          $this->options['_line_open'] = '';
          $this->options['_line_close'] = '<br />';
          $this->options['_blockcode_open'] = '<pre><code>';
          $this->options['_blockcode_close'] = '</code></pre>';
          $this->options['css_mode'] = 1;
        }
      } elseif (preg_match('/^html/', $flavor)) {
        $this->options['_line_open'] = '';
        $this->options['_line_close'] = '<br>';
        $this->options['_blockcode_open'] = '<pre><code>';
        $this->options['_blockcode_close'] = '</code></pre>';
        $this->options['css_mode'] = preg_match('/\/css/', $flavor);
      }
      if ($this->options['css_mode'] && !isset($this->options['css'])) { $this->_css_defaults(); }
    }
    return $this->options['flavor'];
  }
function css($css = NULL) {
    if ($css != NULL) {
      if (is_array($css)) {
        $this->options['css'] = $css;
        $this->options['css_mode'] = 1;
      } else {
        $this->options['css_mode'] = $css;
        if ($this->options['css_mode'] && !isset($this->options['css'])) { $this->_css_defaults(); }
      }
    }
    return ($this->options['css_mode'] ? $this->options['css'] : 0);
  }
  function charset($charset = NULL) {
    if ($charset != NULL) {
        $this->options['charset'] = $charset;
        if (preg_match('/^utf-?8$/i', $this->options['charset'])) {
          $this->char_encoding(0);
        } else {
          $this->char_encoding(1);
        }
    }
    return $this->options['charset'];
  }
 function docroot($docroot = NULL) {
    if ($docroot != NULL) {
      $this->options['docroot'] = $docroot;
    }
    return $this->options['docroot'];
  }
function trim_spaces($trim_spaces = NULL) {
    if ($trim_spaces != NULL) {
      $this->options['trim_spaces'] = $trim_spaces;
    }
    return $this->options['trim_spaces'];
  }
function filter_param($filter_param = NULL) {
    if ($filter_param != NULL) {
      $this->options['filter_param'] = $filter_param;
    }
    return $this->options['filter_param'];
  }
function preserve_spaces($preserve_spaces = NULL) {
    if ($preserve_spaces != NULL) {
      $this->options['preserve_spaces'] = $preserve_spaces;
    }
    return $this->options['preserve_spaces'];
  }
function filters($filters = NULL) {
    if ($filters != NULL) {
      $this->options['filters'] = $filters;
    }
    return $this->options['filters'];
  }
function char_encoding($char_encoding = NULL) {
    if ($char_encoding != NULL) {
      $this->options['char_encoding'] = $char_encoding;
    }
    return $this->options['char_encoding'];
  }
function handle_quotes($do_quotes = NULL) {
    if ($do_quotes != NULL) {
      $this->options['do_quotes'] = $do_quotes;
    }
    return $this->options['do_quotes'];
  }
function _create_re() {
    $this->urlre = '(?:
    # Must start out right...
    (?=[a-zA-Z0-9./#])
    # Match the leading part (proto://hostname, or just hostname)
    (?:
        # ftp://, http://, or https:// leading part
        (?:ftp|https?|telnet|nntp)://(?:\w+(?::\w+)?@)?[-\w]+(?:\.\w[-\w]*)+
        |
        (?:mailto:)?[-\+\w]+@[-\w]+(?:\.\w[-\w]*)+
        |
        # or, try to find a hostname with our more specific sub-expression
        (?i: [a-z0-9] (?:[-a-z0-9]*[a-z0-9])? \. )+ # sub domains
        # Now ending .com, etc. For these, require lowercase
        (?-i: com\b
            | edu\b
            | biz\b
            | gov\b
            | in(?:t|fo)\b # .int or .info
            | mil\b
            | net\b
            | org\b
            | museum\b
            | aero\b
            | coop\b
            | name\b
            | pro\b
            | [a-z][a-z]\b # two-letter country codes
        )
    )?

    # Allow an optional port number
    (?: : \d+ )?

    # The rest of the URL is optional, and begins with / . . .
    (?:
     /?
     # The rest are heuristics for what seems to work well
     [^.!,?;:"\'<>()\[\]{}\s\x7F-\xFF]*
     (?:
        [.!,?;:]+  [^.!,?;:"\'<>()\[\]{}\s\x7F-\xFF]+ #\'"
     )*
    )?
)';

    $this->punct = '[\!"\#\$%&\'()\*\+,\-\./:;<=>\?@\[\\\\\]\^_`{\|}\~]';
    $this->valignre = '[\-^~]';
    $this->tblalignre = '[<>=]';
    $this->halignre = '(?:<>|[<>=])';
    $this->alignre = '(?:(?:' . $this->valignre . '|<>' . $this->valignre . '?|' . $this->valignre . '?<>|' . $this->valignre . '?' . $this->halignre . '?|' . $this->halignre . '?' . $this->valignre . '?)(?!\w))';
    $this->imgalignre = '(?:(?:[<>]|' . $this->valignre . '){1,2})';

    $this->clstypadre = '(?:
  (?:\([A-Za-z0-9_\- \#]+\))
  |
  (?:{
      (?: \( [^)]+ \) | [^\}] )+
     })
  |
  (?:\(+? (?![A-Za-z0-9_\-\#]) )
  |
  (?:\)+?)
  |
  (?: \[ [a-zA-Z\-]+? \] )
)';

    $this->clstyre = '(?:
  (?:\([A-Za-z0-9_\- \#]+\))
  |
  (?:{
      [A-Za-z0-9_\-](?: \( [^)]+ \) | [^\}] )+
     })
  |
  (?: \[ [a-zA-Z\-]+? \] )
)';

    $this->clstyfiltre = '(?:
  (?:\([A-Za-z0-9_\- \#]+\))
  |
  (?:{
      [A-Za-z0-9_\-](?: \( [^)]+ \) | [^\}] )+
     })
  |
  (?:\|[^\|]+\|)
  |
  (?:\(+?(?![A-Za-z0-9_\-\#]))
  |
  (?:\)+)
  |
  (?: \[ [a-zA-Z]+? \] )
)';

    $this->codere = '(?:
    (?:
      [\[{]
      @                           # opening
      (?:\[([A-Za-z0-9]+)\])?     # $1: language id
      (.+?)                       # $2: code
      @                           # closing
      [\]}]
    )
    |
    (?:
      (?:^|(?<=[\s\(]))
      @                           # opening
      (?:\[([A-Za-z0-9]+)\])?     # $3: language id
      ([^\s].+?[^\s])             # $4: code itself
      @                           # closing
      (?:$|(?=' . $this->punct . '{1,2}|\s))
    )
)';

    $this->blocktags = '
    <
    (( /? ( h[1-6]
     | p
     | pre
     | div
     | table
     | t[rdh]
     | [ou]l
     | li
     | block(?:quote|code)
     | form
     | input
     | select
     | option
     | textarea
     )
    [ >]
    )
    | !--
    )
';
  }
function process($str) {
    $macros = array('bq' => 'blockquote');
    array_unshift($this->repl, array());
    $str = preg_replace('!(?:\015?\012|\015)!', "\n", $str);
    if ($this->options['trim_spaces']) { $str = preg_replace('/ +$/m', '', $str); }
    $str = preg_replace_callback('{(^|\n\n)==(.+?)==($|\n\n)}s',
                                 $this->_cb('"$m[1]\n\n" . $me->_repl($me->repl[0], $me->format_block(array("text" => $m[2]))) . "\n\n$m[3]"'), $str);

    if (!$this->disable_html()) {
      $str = preg_replace_callback('!(<(style|script)(?:>| .+?>).*?</\2>)!s', $this->_cb('$me->_repl($me->repl[0], $m[1])'), $str);
      $str = preg_replace_callback('|(<!--.+?-->)|s', $this->_cb('$me->_repl($me->repl[0], $m[1])'), $str);
      $pre_start = count($this->repl[0]);
      $str = preg_replace_callback('{(<pre(?: [^>]*)?>)(.+?)(</pre>)}s',
                                   $this->_cb('"\n\n" . $me->_repl($me->repl[0], $m[1] . $me->encode_html($m[2], 1) . $m[3]) . "\n\n"'), $str);
      for ($i = $pre_start; $i < count($this->repl[0]); $i++) {
        $this->repl[0][$i] = preg_replace('|&lt;(/?)code(.*?)&gt;|s', '<$1code$2>', $this->repl[0][$i]);
      }
      $str = preg_replace_callback('{(<code(?: [^>]+)?>)(.+?)(</code>)}s',
                                   $this->_cb('$me->_repl($me->repl[0], $m[1] . $me->encode_html($m[2], 1) . $m[3])'), $str);
      $str = preg_replace_callback('{(<blockcode(?: [^>]+)?>)(.+?)(</blockcode>)}s',
                                   $this->_cb('"\n\n" . $me->_repl($me->repl[0], $m[1] . $me->encode_html($m[2], 1) . $m[3]) . "\n\n"'), $str);

      $str = preg_replace_callback('!(<([\?%]).*?(\2)>)!s', $this->_cb('$me->_repl($me->repl[0], $m[1])'), $str);
    }
    $str = preg_replace_callback('{(?:\n|^) [ ]* \[ ([^ ]+?) [ ]*? (?:\( (.+?) \) )?  \] ((?:(?:ftp|https?|telnet|nntp)://|/)[^ ]+?) [ ]* (\n|$)}mx',
                                 $this->_cb('($me->links[$m[1]] = array("url" => $m[3], "title" => $m[2])) ? $m[4] : $m[4]'), $str);
    $str = preg_replace('/^\n+/s', '', $str, 1);
    $str = preg_replace('/\n+$/s', '', $str, 1);
    $para = preg_split('/(\n{2,})/', $str, -1, PREG_SPLIT_DELIM_CAPTURE);
    unset($block, $bqlang, $filter, $class, $sticky, $lines,
          $style, $stickybuff, $lang, $clear);

    $out = '';

    foreach ($para as $para) {
      if (preg_match('/^\n+$/s', $para)) {
        if ($sticky && $stickybuff) {
          $stickybuff .= $para;
        } else {
          $out .= $para;
        }
        continue;
      }

      if ($sticky) {
        $sticky++;
      } else {
        unset($block);
        unset($class);
        $style = '';
        unset($lang);
      }

      unset($id, $cite, $align, $padleft, $padright, $lines, $buffer);
      if (preg_match('{^(h[1-6]|p|bq|bc|fn\d+)
                        ((?:' . $this->clstyfiltre . '*|' . $this->halignre . ')*)
                        (\.\.?)
                        (?::(\d+|' . $this->urlre . '))?\ (.*)$}sx', $para, $matches)) {
        if ($sticky) {
          if ($block == 'bc') {
            $out = preg_replace('/\n\n$/', '', $out, 1);
            $out .= $this->options['_blockcode_close'] . "\n\n";
          } elseif ($block == 'bq') {
            $out = preg_replace('/\n\n$/', '', $out, 1);
            $out .= '</blockquote>' . "\n\n";
          } elseif ($block == 'table') {
            $table_out = $this->format_table(array('text' => $stickybuff));
            if (!$table_out) { $table_out = ''; }
            $out .= $table_out;
            unset($stickybuff);
          } elseif ($block == 'dl') {
            $dl_out = $this->format_deflist(array('text' => $stickybuff));
            if (!$dl_out) { $dl_out = ''; }
            $out .= $dl_out;
            unset($stickybuff);
          }
          $sticky = 0;
        }
        $block = $matches[1];
        $params = $matches[2];
        $cite = $matches[4];
        if ($matches[3] == '..') {
          $sticky = 1;
        } else {
          $sticky = 0;
          unset($class);
          unset($bqlang);
          unset($lang);
          $style = '';
          unset($filter);
        }
        if (preg_match('/^h([1-6])$/', $block, $matches2)) {
          if ($this->options['head_offset']) {
            $block = 'h' . ($matches2[1] + $this->options['head_offset']);
          }
        }
        if (preg_match('{(' . $this->halignre . '+)}', $params, $matches2)) {
          $align = $matches2[1];
          $params = preg_replace('{' . $this->halignre . '+}', '', $params, 1);
        }
        if ($params) {
          if (preg_match('/\|(.+)\|/', $params, $matches2)) {
            $filter = $matches2[1];
            $params = preg_replace('/\|.+?\|/', '', $params, 1);
          }
          if (preg_match('/{([^}]+)}/', $params, $matches2)) {
            $style = $matches2[1];
            $style = preg_replace('/\n/', ' ', $style);
            $params = preg_replace('/{[^}]+}/', '', $params);
          }
          if (preg_match('/\(([A-Za-z0-9_\-\ ]+?)(?:\#(.+?))?\)/', $params, $matches2) ||
              preg_match('/\(([A-Za-z0-9_\-\ ]+?)?(?:\#(.+?))\)/', $params, $matches2)) {
            if ($matches2[1] || $matches2[2]) {
              $class = $matches2[1];
              $id = $matches2[2];
              if ($class) {
                $params = preg_replace('/\([A-Za-z0-9_\-\ ]+?(#.*?)?\)/', '', $params);
              } elseif ($id) {
                $params = preg_replace('/\(#.+?\)/', '', $params);
              }
            }
          }
          if (preg_match('/(\(+)/', $params, $matches2)) {
            $padleft = strlen($matches2[1]);
            $params = preg_replace('/\(+/', '', $params, 1);
          }
          if (preg_match('/(\)+)/', $params, $matches2)) {
            $padright = strlen($matches2[1]);
            $params = preg_replace('/\)+/', '', $params, 1);
          }
          if (preg_match('/\[(.+?)\]/', $params, $matches2)) {
            $lang = $matches2[1];
            if ($block == 'bc') {
              $bqlang = $lang;
              unset($lang);
            }
            $params = preg_replace('/\[.+?\]/', '', $params, 1);
          }
        }
        $para = $matches[5];
      } elseif (preg_match('|^<textile#(\d+)>$|', $para, $matches)) {
        $buffer = $this->repl[0][$matches[1] - 1];
      } elseif (preg_match('/^clear([<>]+)?\.$/', $para, $matches)) {
        if ($matches[1] == '<') {
          $clear = 'left';
        } elseif ($matches[1] == '>') {
          $clear = 'right';
        } else {
          $clear = 'both';
        }
        continue;
      } elseif ($sticky && $stickybuff &&
                ($block == 'table' || $block == 'dl')) {
        $stickybuff .= $para;
        continue;
      } elseif (preg_match('{^(?:' . $this->halignre . '|' . $this->clstypadre . '*)*
                              [\*\#]
                              (?:' . $this->halignre . '|' . $this->clstypadre . '*)*
                              \ }x', $para)) {
        $buffer = $this->format_list(array('text' => $para));
      } elseif (preg_match('{^(?:table(?:' . $this->tblalignre . '|' . $this->clstypadre . '*)*
                              (\.\.?)\s+)?
                              (?:_|' . $this->alignre . '|' . $this->clstypadre . '*)*\|}x', $para, $matches)) {
        if ($matches[1] && ($matches[1] == '..')) {
          $block = 'table';
          $stickybuff = $para;
          $sticky = 1;
          continue;
        } else {
          $buffer = $this->format_table(array('text' => $para));
        }
      } elseif (preg_match('{^(?:dl(?:' . $this->clstyre . ')*(\.\.?)\s+)}x', $para, $matches)) {
        if ($matches[1] && ($matches[1] == '..')) {
          $block = 'dl';
          $stickybuff = $para;
          $sticky = 1;
          continue;
        } else {
          $buffer = $this->format_deflist(array('text' => $para));
        }
      }
      if ($buffer) {
        $out .= $buffer;
        continue;
      }
      $lines = preg_split('/\n/', $para);
      if ((count($lines) == 1) && ($lines[0] == '')) {
        continue;
      }

      $block = ($block ? $block : 'p');

      $buffer = '';
      $pre = '';
      $post = '';

      if ($block == 'bc') {
        if ($sticky <= 1) {
          $pre .= $this->options['_blockcode_open'];
          $pre = preg_replace('/>$/s', '', $pre, 1);
          if ($bqlang) { $pre .= " language=\"$bqlang\""; }
          if ($align) {
            $alignment = $this->_halign($align);
            if ($this->options['css_mode']) {
              if (($padleft || $padright) &&
                  (($alignment == 'left') || ($alignment == 'right'))) {
                $style .= ';float:' . $alignment;
              } else {
                $style .= ';text-align:' . $alignment;
              }
              $class .= ' ' . ($this->options['css']["class_align_$alignment"] ? $this->options['css']["class_align_$alignment"] : $alignment);
            } else {
              if ($alignment) { $pre .= " align=\"$alignment\""; }
            }
          }
          if ($padleft) { $style .= ";padding-left:${padleft}em"; }
          if ($padright) { $style .= ";padding-right:${padright}em"; }
          if ($clear) { $style .= ";clear:${clear}"; }
          if ($class) { $class = preg_replace('/^ /', '', $class, 1); }
          if ($class) { $pre .= " class=\"$class\""; }
          if ($id) { $pre .= " id=\"$id\""; }
          if ($style) { $style = preg_replace('/^;/', '', $style, 1); }
          if ($style) { $pre .= " style=\"$style\""; }
          if ($lang) { $pre .= " lang=\"$lang\""; }
          $pre .= '>';
          unset($lang);
          unset($bqlang);
          unset($clear);
        }
        $para = preg_replace_callback('{(?:^|(?<=[\s>])|([{[]))
                                        ==(.+?)==
                                        (?:$|([\]}])|(?=' . $this->punct . '{1,2}|\s))}sx',
                                      $this->_cb('$me->_repl($me->repl[0], $me->format_block(array("text" => $m[2], "inline" => 1, "pre" => $m[1], "post" => $m[3])))'), $para);
        $buffer .= $this->encode_html_basic($para, 1);
        $buffer = preg_replace('/&lt;textile#(\d+)&gt;/', '<textile#$1>', $buffer);
        if ($sticky == 0) {
          $post .= $this->options['_blockcode_close'];
        }
        $out .= $pre . $buffer . $post;
        continue;
      } elseif ($block == 'bq') {
        if ($sticky <= 1) {
          $pre .= '<blockquote';
          if ($align) {
            $alignment = $this->_halign($align);
            if ($this->options['css_mode']) {
              if (($padleft || $padright) &&
                  (($alignment == 'left') || ($alignment == 'right'))) {
                $style .= ';float:' . $alignment;
              } else {
                $style .= ';text-align:' . $alignment;
              }
              $class .= ' ' . ($this->options['css']["class_align_$alignment"] ? $this->options['css']["class_align_$alignment"] : $alignment);
            } else {
              if ($alignment) { $pre .= " align=\"$alignment\""; }
            }
          }
          if ($padleft) { $style .= ";padding-left:${padleft}em"; }
          if ($padright) { $style .= ";padding-right:${padright}em"; }
          if ($clear) { $style .= ";clear:${clear}"; }
          if ($class) { $class = preg_replace('/^ /', '', $class, 1); }
          if ($class) { $pre .= " class=\"$class\""; }
          if ($id) { $pre .= " id=\"$id\""; }
          if ($style) { $style = preg_replace('/^;/', '', $style, 1); }
          if ($style) { $pre .= " style=\"$style\""; }
          if ($lang) { $pre .= " lang=\"$lang\""; }
          if ($cite) { $pre .= ' cite="' . $this->format_url(array('url' => $cite)) . '"'; }
          $pre .= '>';
          unset($clear);
        }
        $pre .= '<p>';
      } elseif (preg_match('/fn(\d+)/', $block, $matches)) {
        $fnum = $matches[1];
        $pre .= '<p';
        if ($this->options['css']['class_footnote']) { $class .= ' ' . $this->options['css']['class_footnote']; }
        if ($align) {
          $alignment = $this->_halign($align);
          if ($this->options['css_mode']) {
            if (($padleft || $padright) &&
                (($alignment == 'left') || ($alignment == 'right'))) {
              $style .= ';float:' . $alignment;
            } else {
              $style .= ';text-align:' . $alignment;
            }
            $class .= ($this->options['css']["class_align_$alignment"] ? $this->options['css']["class_align_$alignment"] : $alignment);
          } else {
            $pre .= " align=\"$alignment\"";
          }
        }
        if ($padleft) { $style .= ";padding-left:${padleft}em"; }
        if ($padright) { $style .= ";padding-right:${padright}em"; }
        if ($clear) { $style .= ";clear:${clear}"; }
        if ($class) { $class = preg_replace('/^ /', '', $class, 1); }
        if ($class) { $pre .= " class=\"$class\""; }
        $pre .= ' id="' . ($this->options['css']['id_footnote_prefix'] ? $this->options['css']['id_footnote_prefix'] : 'fn') . $fnum . '"';
        if ($style) { $style = preg_replace('/^;/', '', $style, 1); }
        if ($style) { $pre .= " style=\"$style\""; }
        if ($lang) { $pre .= " lang=\"$lang\""; }
        $pre .= '>';
        $pre .= '<sup>' . $fnum . '</sup> ';
        $block = 'p';
        unset($clear);
      } else {
        $pre .= '<' . ($macros[$block] ? $macros[$block] : $block);
        if ($align) {
          $alignment = $this->_halign($align);
          if ($this->options['css_mode']) {
            if (($padleft || $padright) &&
                (($alignment == 'left') || ($alignment == 'right'))) {
              $style .= ';float:' . $alignment;
            } else {
              $style .= ';text-align:' . $alignment;
            }
            $class .= ' ' . ($this->options['css']["class_align_$alignment"] ? $this->options['css']["class_align_$alignment"] : $alignment);
          } else {
            $pre .= " align=\"$alignment\"";
          }
        }
        if ($padleft) { $style .= ";padding-left:${padleft}em"; }
        if ($padright) { $style .= ";padding-right:${padright}em"; }
        if ($clear) { $style .= ";clear:${clear}"; }
        if ($class) { $class = preg_replace('/^ /', '', $class, 1); }
        if ($class) { $pre .= " class=\"$class\""; }
        if ($id) { $pre .= " id=\"$id\""; }
        if ($style) { $style = preg_replace('/^;/', '', $style, 1); }
        if ($style) { $pre .= " style=\"$style\""; }
        if ($lang) { $pre .= " lang=\"$lang\""; }
        if ($cite && ($block == 'bq')) { $pre .= ' cite="' . $this->format_url(array('url' => $cite)) . '"'; }
        $pre .= '>';
        unset($clear);
      }

      $buffer = $this->format_paragraph(array('text' => $para));

      if ($block == 'bq') {
        if (!preg_match('/<p[ >]/', $buffer)) { $post .= '</p>'; }
        if ($sticky == 0) {
          $post .= '</blockquote>';
        }
      } else {
        $post .= '</' . $block . '>';
      }

      if (preg_match('{' . $this->blocktags . '}x', $buffer)) {
        $buffer = preg_replace('/^\n\n/s', '', $buffer, 1);
        $out .= $buffer;
      } else {
        if ($filter) { $buffer = $this->format_block(array('text' => "|$filter|" . $buffer, 'inline' => 1)); }
        $out .= $pre . $buffer . $post;
      }
    }

    if ($sticky) {
      if ($block == 'bc') {
        $out .= $this->options['_blockcode_close']; // . "\n\n";
      } elseif ($block == 'bq') {
        $out .= '</blockquote>'; // . "\n\n";
      } elseif (($block == 'table') && $stickybuff) {
        $table_out = $this->format_table(array('text' => $stickybuff));
        if ($table_out) { $out .= $table_out; }
      } elseif (($block == 'dl') && $stickybuff) {
        $dl_out = $this->format_deflist(array('text' => $stickybuff));
        if ($dl_out) { $out .= $dl_out; }
      }
    }
    for ($i = count($this->repl[0]); $i > 0; $i--) {
      $out = preg_replace('!(?:<|&lt;)textile#' . $i . '(?:>|&gt;)!', str_replace('$', '\\$', $this->repl[0][$i - 1]), $out, 1);
    }
    array_shift($this->repl);
    if (preg_match('/^xhtml/i', $this->flavor())) {
      $out = preg_replace('/(<(?:img|br|hr)[^>]*?(?<!\/))>/', '$1 />', $out);
    }

    return $out;
  }
function format_paragraph($args) {
    $buffer = (isset($args['text']) ? $args['text'] : '');

    array_unshift($this->repl, array());
    $buffer = preg_replace_callback('{(?:^|(?<=[\s>])|([{[]))
                                      ==(.+?)==
                                      (?:$|([\]}])|(?=' . $this->punct . '{1,2}|\s))}sx',
                                    $this->_cb('$me->_repl($me->repl[0], $me->format_block(array("text" => $m[2], "inline" => 1, "pre" => $m[1], "post" => $m[3])))'), $buffer);

    unset($tokens);
    if (preg_match('/</', $buffer) && (!$this->disable_html())) { 
      $tokens = $this->_tokenize($buffer);
    } else {
      $tokens = array(array('text', $buffer));
    }
    $result = '';
    foreach ($tokens as $token) {
      $text = $token[1];
      if ($token[0] == 'tag') {
        $text = preg_replace('/&(?!amp;)/', '&amp;', $text);
        $result .= $text;
      } else {
        $text = $this->format_inline(array('text' => $text));
        $result .= $text;
      }
    }
    $lines = preg_split('/\n/', $result);
    $result = '';
    $needs_closing = 0;
    foreach ($lines as $line) {
      if (!preg_match('{(' . $this->blocktags . ')}x', $line)
          && ((preg_match('/^[^<]/', $line) || preg_match('/>[^<]/', $line))
              || !preg_match('/<img /', $line))) {
        if ($this->options['_line_open']) {
          if ($result != '') { $result .= "\n"; }
          $result .= $this->options['_line_open'] . $line . $this->options['_line_close'];
        } else {
          if ($needs_closing) {
            $result .= $this->options['_line_close'] . "\n";
          } else {
            $needs_closing = 1;
            if ($result != '') { $result .= "\n"; }
          }
          $result .= $line;
        }
      } else {
        if ($needs_closing) {
          $result .= $this->options['_line_close'] . "\n";
        } else {
          if ($result != '') { $result .= "\n"; }
        }
        $result .= $line;
        $needs_closing = 0;
      }
    }

    $result = preg_replace('/\001/', "\n", $result);

    for ($i = count($this->repl[0]); $i > 0; $i--) {
      $result = preg_replace("|<textile#$i>|", str_replace('$', '\\$', $this->repl[0][$i - 1]), $result, 1);
    }
    array_shift($this->repl);

    if ($this->options['do_quotes']) {
      $result = $this->process_quotes($result);
    }

    return $result;
  }
  function format_inline($args) {
    $qtags = array(array('**', 'b',      '(?<!\*)\*\*(?!\*)', '\*'),
                   array('__', 'i',      '(?<!_)__(?!_)', '_'),
                   array('??', 'cite',   '\?\?(?!\?)', '\?'),
                   array('*',  'strong', '(?<!\*)\*(?!\*)', '\*'),
                   array('_',  'em',     '(?<!_)_(?!_)', '_'),
                   array('-',  'del',    '(?<!\-)\-(?!\-)', '-'),
                   array('+',  'ins',    '(?<!\+)\+(?!\+)', '\+'),
                   array('++', 'big',    '(?<!\+)\+\+(?!\+)', '\+\+'),
                   array('--', 'small',  '(?<!\-)\-\-(?!\-)', '\-\-'),
                   array('~',  'sub',    '(?<!\~)\~(?![\\\\/~])', '\~'));
    $text = (isset($args['text']) ? $args['text'] : '');

    array_unshift($this->repl, array());

    $text = preg_replace_callback('{' . $this->codere . '}mx', $this->_cb('$me->_repl($me->repl[0], $me->format_code(array("text" => $m[2] . $m[4], "lang" => $m[1] . $m[3])))'), $text);
    $text = preg_replace_callback('{(?:^|(?<=[\s>])|([{[]))      # $1: open brace/bracket
                                    !                            # opening
                                    (' . $this->imgalignre . '?) # $2: optional alignment
                                    (' . $this->clstypadre . '*) # $3: optional CSS class/id
                                    (' . $this->imgalignre . '?) # $4: optional alignment
                                    (?:\s*)                      # space between alignment/css stuff
                                    ([^\s\(!]+)                  # $5: filename
                                    (\s*[^\(!]*(?:\([^\)]+\))?[^!]*) # $6: extras (alt text)
                                    !                            # closing
                                    (?::(\d+|' . $this->urlre . '))? # $7: optional URL
                                    (?:$|([\]}])|(?=' . $this->punct . '{1,2}|\s)) # $8: closing brace/bracket
                                   }mx', $this->_cb('$me->_repl($me->repl[0], $me->format_image(array("pre" => $m[1], "src" => $m[5], "align" => ($m[2] ? $m[2] : $m[4]), "extra" => $m[6], "url" => $m[7], "clsty" => $m[3], "post" => $m[8])))'), $text);

    $text = preg_replace_callback('{(?:^|(?<=[\s>])|([{[]))     # $1: open brace/bracket
                                    %                           # opening
                                    (' . $this->halignre . '?)  # $2: optional alignment
                                    (' . $this->clstyre . '*)   # $3: optional CSS class/id
                                    (' . $this->halignre . '?)  # $4: optional alignment
                                    (?:\s*)                     # spacing
                                    ([^%]+?)                    # $5: text
                                    %                           # closing
                                    (?::(\d+|' . $this->urlre . '))? # $6: optional URL
                                    (?:$|([]}])|(?=' . $this->punct . '{1,2}|\s)) # $7: closing brace/bracket
                                   }mx', $this->_cb('$me->_repl($me->repl[0], $me->format_span(array("pre" => $m[1], "text" => $m[5], "align" => ($m[2] ? $m[2] : $m[4]), "cite" => $m[6], "clsty" => $m[3], "post" => $m[7])))'), $text);

    $text = $this->encode_html($text);
    $text = preg_replace('!&lt;textile#(\d+)&gt;!', '<textile#$1>', $text);
    $text = preg_replace('!&amp;quot;!', '&#34;', $text);
    $text = preg_replace('!&amp;(([a-z]+|#\d+);)!', '&$1', $text);
    $text = preg_replace('!&quot;!', '"', $text);
    $parenre = '\( (?: [^()] )* \)';
    $text = preg_replace_callback('{(
                                    [{[]
                                    (?:
                                        (?:"                                         # quote character
                                           (' . $this->clstyre . '*)?                # $2: optional CSS class/id
                                           ([^"]+?)                                  # $3: link text
                                           (?:\( ( (?:[^()]|' . $parenre . ')*) \))? # $4: optional link title
                                           "                                         # closing quote
                                        )
                                        |
                                        (?:\'                                        # open single quote
                                           (' . $this->clstyre . '*)?                # $5: optional CSS class/id
                                           ([^\']+?)                                 # $6: link text
                                           (?:\( ( (?:[^()]|' . $parenre . ')*) \))? # $7: optional link title
                                           \'                                        # closing quote
                                        )
                                    )
                                    :(.+?)                                           # $8: URL suffix
                                    [\]}]
                                   )
                                   }mx', $this->_cb('$me->_repl($me->repl[0], $me->format_link(array("text" => $m[1], "linktext" => $m[3] . $m[6], "title" => $me->encode_html_basic($m[4] . $m[7]), "url" => $m[8], "clsty" => $m[2] . $m[5])))'), $text);

    $text = preg_replace_callback('{((?:^|(?<=[\s>\(]))                              # $1: open brace/bracket
                                    (?: (?:"                                         # quote character "
                                           (' . $this->clstyre . '*)?                # $2: optional CSS class/id
                                           ([^"]+?)                                  # $3: link text "
                                           (?:\( ( (?:[^()]|' . $parenre . ')*) \))? # $4: optional link title
                                           "                                         # closing quote # "
                                        )
                                        |
                                        (?:\'                                        # open single quote \'
                                           (' . $this->clstyre . '*)?                # $5: optional CSS class/id
                                           ([^\']+?)                                 # $6: link text \'
                                           (?:\( ( (?:[^()]|' . $parenre . ')*) \))? # $7: optional link title
                                           \'                                        # closing quote \'
                                        )
                                    )
                                    :(\d+|' . $this->urlre . ')                      # $8: URL suffix
                                    (?:$|(?=' . $this->punct . '{1,2}|\s)))          # $9: closing brace/bracket
                                   }mx', $this->_cb('$me->_repl($me->repl[0], $me->format_link(array("text" => $m[1], "linktext" => $m[3] . $m[6], "title" => $me->encode_html_basic($m[4] . $m[7]), "url" => $m[8], "clsty" => $m[2] . $m[5])))'), $text);

    if (preg_match('/^xhtml2/', $this->flavor())) {
      $text = preg_replace_callback('{(?:^|(?<=[\s>\'"\(])|([{[]))                   # $1: open brace/bracket \'
                                      \?\?                                           # opening \'??\'
                                      ([^\?]+?)                                      # $2: characters (can\'t contain \'?\')
                                      \?\?                                           # closing \'??\'
                                      :(\d+|' . $this->urlre . ')                    # $3: optional citation URL
                                      (?:$|([\]}])|(?=' . $this->punct . '{1,2}|\s)) # $4: closing brace/bracket
                                     }mx', $this->_cb('$me->_repl($me->repl[0], $me->format_cite(array("pre" => $m[1], "text" => $m[2], "cite" => $m[3], "post" => $m[4])))'), $text);
    }

    if (preg_match('/[^ ]\[\d+\]/', $text)) {
      $fntag = '<sup';
      if ($this->options['css']['class_footnote']) { $fntag .= ' class="' . $this->options['css']['class_footnote'] . '"'; }
      $fntag .= '><a href="#' . ($this->options['css']['id_footnote_prefix'] ? $this->options['css']['id_footnote_prefix'] : 'fn');
      $text = preg_replace('|([^ ])\[(\d+)\]|', '$1' . $fntag . '$2">$2</a></sup>', $text);
    }

    $text = preg_replace_callback('{(\{)(.+?)(\})}x',
                                  $this->_cb('$me->format_macro(array("pre" => $m[1], "post" => $m[3], "macro" => $m[2]))'), $text);

    $text = preg_replace('|[\(\[]TM[\)\]]|i', '&#8482;', $text);
    $text = preg_replace('|[\(\[]C[\)\]]|i', '&#169;', $text);
    $text = preg_replace('|[\(\[]R[\)\]]|i', '&#174;', $text);

    if ($this->preserve_spaces()) {
      $text = preg_replace('/(?<!\s)\ \ (?!=\s)/', '&#8195;', $text);
    }

    $redo = preg_match('/[\*_\?\-\+\^\~]/', $text);
    $last = $text;
    while ($redo) {
      $redo = 0;
      foreach ($qtags as $tag) {
        list ($this->tmp['f'][], $this->tmp['r'][], $qf, $cls) = $tag;
        if ($last != ($text = preg_replace_callback('{(?:^|(?<=[\s>\'"])|([{[]))                     # "\' $1 - pre
                                                      ' . $qf . '                                    #
                                                      (?:(' . $this->clstyre . '*))?                 # $2 - attributes
                                                      ([^' . $cls . '\s].*?)                         # $3 - content
                                                      (?<=\S)' . $qf . '                             #
                                                      (?:$|([\]}])|(?=' . $this->punct . '{1,2}|\s)) # $4 - post
                                                     }mx', $this->_cb('$me->format_tag(array("tag" => end($me->tmp["r"]), "marker" => end($me->tmp["f"]), "pre" => $m[1], "text" => $m[3], "clsty" => $m[2], "post" => $m[4]))'), $text))) {
          $redo = ($redo || ($last != $text));
          $last = $text;
        }
        array_pop($this->tmp['f']); array_pop($this->tmp['r']);
      }
    }

    $text = preg_replace('/(?<!\^)\^(?!\^)(.+?)(?<!\^)\^(?!\^)/', '<sup>$1</sup>', $text);

    $text = preg_replace_callback('{\b([A-Z][A-Za-z0-9]*?[A-Z0-9]+?)\b(?:[(]([^)]*)[)])}',
                                  $this->_cb('$me->_repl($me->repl[0],"<acronym title=\"" . $me->encode_html_basic($m[2]) . "\">$m[1]</acronym>")'), $text);

    if ($this->tmp['caps'][] = $this->options['css']['class_caps']) {
      $text = preg_replace_callback('/(^|[^"][>\s])  # "
                                      ((?:[A-Z](?:[A-Z0-9\.,\']|\&amp;){2,}\ *)+?) # \'
                                      (?=[^A-Z\.0-9]|$)
                                     /mx', $this->_cb('$m[1] . $me->_repl($me->repl[0], "<span class=\"" . end($me->tmp["caps"]) . "\">$m[2]</span>")'), $text);
    }
    array_pop($this->tmp['caps']);

    $text = preg_replace('!((?:[0-9\.]0|[1-9]|\d[\'"])\ ?)x(\ ?\d)!', '$1&#215;$2', $text);

    $text = preg_replace('/&#133;/', '&#8230;', $text);
    $text = preg_replace('/&#145;/', '&#8216;', $text);
    $text = preg_replace('/&#146;/', '&#8217;', $text);
    $text = preg_replace('/&#147;/', '&#8220;', $text);
    $text = preg_replace('/&#148;/', '&#8221;', $text);
    $text = preg_replace('/&#150;/', '&#8211;', $text);
    $text = preg_replace('/&#151;/', '&#8212;', $text);

    for ($i = count($this->repl[0]); $i > 0; $i--) {
      $text = preg_replace("|<textile#$i>|", str_replace('$', '\\$', $this->repl[0][$i - 1]), $text);
    }
    array_shift($this->repl);
    return $text;
  }
function format_macro($attrs) {
    $macro = $attrs['macro'];
    if ($this->options['macros'][$macro]) {
      return $this->options['macros'][$macro];
    }

    return $attrs['pre'] . $macro . $attrs['post'];
  }
function format_cite($args) {
    $pre = (isset($args['pre']) ? $args['pre'] : '');
    $text = (isset($args['text']) ? $args['text'] : '');
    $cite = $args['cite'];
    $post = (isset($args['post']) ? $args['post'] : '');
    $this->_strip_borders($pre, $post);
    $tag = $pre . '<cite';
    if (preg_match('/^xhtml2/', $this->flavor()) && $cite) {
      $cite = $this->format_url(array('url' => $cite));
      $tag .= " cite=\"$cite\"";
    } else {
      $post .= ':';
    }
    $tag .= '>';
    return $tag . $this->format_inline(array('text' => $text)) . '</cite>' . $post;
  }
function format_code($args) {
    $code = (isset($args['text']) ? $args['text'] : '');
    $lang = $args['lang'];
    $code = $this->encode_html($code, 1);
    $code = preg_replace('/&lt;textile#(\d+)&gt;/', '<textile#$1>', $code);
    $tag = '<code';
    if ($lang) { $tag .= " language=\"$lang\""; }
    return $tag . '>' . $code . '</code>';
  }
function format_classstyle($clsty = NULL, $class = NULL, $style = NULL) {
    $class = preg_replace('/^ /', '', $class, 1);

    unset($lang, $padleft, $padright, $id);
    if ($clsty && preg_match('/{([^}]+)}/', $clsty, $matches)) {
      $_style = $matches[1];
      $_style = preg_replace('/\n/', ' ', $_style);
      $style .= ';' . $_style;
      $clsty = preg_replace('/{[^}]+}/', '', $clsty);
    }
    if ($clsty && (preg_match('/\(([A-Za-z0-9_\- ]+?)(?:#(.+?))?\)/', $clsty, $matches) ||
                   preg_match('/\(([A-Za-z0-9_\- ]+?)?(?:#(.+?))\)/', $clsty, $matches))) {
      if ($matches[1] || $matches[2]) {
        if ($class) {
          $class = $matches[1] . ' ' . $class;
        } else {
          $class = $matches[1];
        }
        $id = $matches[2];
        if ($class) {
          $clsty = preg_replace('/\([A-Za-z0-9_\- ]+?(#.*?)?\)/', '', $clsty);
        }
        if ($id) {
          $clsty = preg_replace('/\(#.+?\)/', '', $clsty);
        }
      }
    }
    if ($clsty && preg_match('/(\(+)/', $clsty, $matches)) {
      $padleft = strlen($matches[1]);
      $clsty = preg_replace('/\(+/', '', $clsty, 1);
    }
    if ($clsty && preg_match('/(\)+)/', $clsty, $matches)) {
      $padright = strlen($matches[1]);
      $clsty = preg_replace('/\)+/', '', $clsty, 1);
    }
    if ($clsty && preg_match('/\[(.+?)\]/', $clsty, $matches)) {
      $lang = $matches[1];
      $clsty = preg_replace('/\[.+?\]/', '', $clsty);
    }
    $attrs = '';
    if ($padleft) { $style .= ";padding-left:${padleft}em"; }
    if ($padright) { $style .= ";padding-right:${padright}em"; }
    $style = preg_replace('/^;/', '', $style, 1);
    $class = preg_replace('/^ /', '', $class, 1);
    $class = preg_replace('/ $/', '', $class, 1);
    if ($class) { $attrs .= " class=\"$class\""; }
    if ($id) { $attrs .= " id=\"$id\""; }
    if ($style) { $attrs .= " style=\"$style\""; }
    if ($lang) { $attrs .= " lang=\"$lang\""; }
    $attrs = preg_replace('/^ /', '', $attrs, 1);
    return $attrs;
  }
function format_tag($args) {
    $tagname = $args['tag'];
    $text = (isset($args['text']) ? $args['text'] : '');
    $pre = (isset($args['pre']) ? $args['pre'] : '');
    $post = (isset($args['post']) ? $args['post'] : '');
    $clsty = (isset($args['clsty']) ? $args['clsty'] : '');
    $this->_strip_borders($pre, $post);
    $tag = "<$tagname";
    $attr = $this->format_classstyle($clsty);
    if ($attr) { $tag .= " $attr"; }
    $tag .= ">$text</$tagname>";
    return $pre . $tag . $post;
  }
function format_deflist($args) {
    $str = (isset($args['text']) ? $args['text'] : '');
    unset($clsty);
    $lines = preg_split('/\n/', $str);
    if (preg_match('{^(dl(' . $this->clstyre . '*?)\.\.?(?:\ +|$))}x', $lines[0], $matches)) {
      $clsty = $matches[2];
      $lines[0] = substr($lines[0], strlen($matches[1]));
    }

    unset($dt, $dd);
    $out = '';
    foreach ($lines as $line) {
      if (preg_match('{^((?:' . $this->clstyre . '*)(?:[^\ ].*?)(?<!["\'\ ])):([^\ \/].*)$}x', $line, $matches)) {
        if ($dt && $dd) { $out .= $this->add_term($dt, $dd); }
        $dt = $matches[1];
        $dd = $matches[2];
      } else {
        $dd .= "\n" . $line;
      }
    }
    if ($dt && $dd) { $out .= $this->add_term($dt, $dd); }

    $tag = '<dl';
    if ($clsty) { $attr = $this->format_classstyle($clsty); }
    if ($attr) { $tag .= " $attr"; }
    $tag .= '>' . "\n";

    return $tag . $out . "</dl>\n";
  }
function add_term($dt, $dd) {
    unset($dtattr, $ddattr);
    unset($dtlang);
    if (preg_match('{^(' . $this->clstyre . '*)}x', $dt, $matches)) {
      $param = $matches[1];
      $dtattr = $this->format_classstyle($param);
      if (preg_match('/\[([A-Za-z]+?)\]/', $param, $matches)) {
        $dtlang = $matches[1];
      }
      $dt = substr($dt, strlen($param));
    }
    if (preg_match('{^(' . $this->clstyre . '*)}x', $dd, $matches)) {
      $param = $matches[1];
      if ($dtlang && preg_match('/\[([A-Za-z]+?)\]/', $param)) {
        unset($dtlang);
      }
      $ddattr = $this->format_classstyle(($dtlang ? "[$dtlang]" : '') . $param);
      $dd = substr($dd, strlen($param));
    }
    $out = '<dt';
    if ($dtattr) { $out .= " $dtattr"; }
    $out .= '>' . $this->format_inline(array('text' => $dt)) . '</dt>' . "\n";
    if (preg_match('/\n\n/', $dd)) {
      if (preg_match('/\n\n/', $dd)) { $dd = $this->process($dd); }
    } else {
      $dd = $this->format_paragraph(array('text' => $dd));
    }
    $out .= '<dd';
    if ($ddattr) { $out .= " $ddattr"; }
    $out .= '>' . $dd . '</dd>' . "\n";
    return $out;
  }
function format_list($args) {
    $str = (isset($args['text']) ? $args['text'] : '');

    $list_tags = array('*' => 'ul', '#' => 'ol');

    $lines = preg_split('/\n/', $str);

    unset($stack);
    $last_depth = 0;
    $item = '';
    $out = '';
    foreach ($lines as $line) {
      if (preg_match('{^((?:' . $this->clstypadre . '*|' . $this->halignre . ')*)
                       ([\#\*]+)
                       ((?:' . $this->halignre . '|' . $this->clstypadre . '*)*)
                       \ (.+)$}x', $line, $matches)) {
        if ($item != '') {
          if (preg_match('/\n/', $item)) {
            if ($this->options['_line_open']) {
              $item = preg_replace('/(<li[^>]*>|^)/m', '$1' . $this->options['_line_open'], $item);
              $item = preg_replace('/(\n|$)/s', $this->options['_line_close'] . '$1', $item);
            } else {
              $item = preg_replace('/(\n)/s', $this->options['_line_close'] . '$1', $item);
            }
          }
          $out .= $item;
          $item = '';
        }
        $type = substr($matches[2], 0, 1);
        $depth = strlen($matches[2]);
        $blockparam = $matches[1];
        $itemparam = $matches[3];
        $line = $matches[4];
        unset ($blockclsty, $blockalign, $blockattr, $itemattr, $itemclsty,
               $itemalign);
        if (preg_match('{(' . $this->clstypadre . '+)}x', $blockparam, $matches)) {
          $blockclsty = $matches[1];
        }
        if (preg_match('{(' . $this->halignre . '+)}', $blockparam, $matches)) {
          $blockalign = $matches[1];
        }
        if (preg_match('{(' . $this->clstypadre . '+)}x', $itemparam, $matches)) {
          $itemclsty = $matches[1];
        }
        if (preg_match('{(' . $this->halignre . '+)}', $itemparam, $matches)) {
          $itemalign = $matches[1];
        }
        if ($itemclsty) { $itemattr = $this->format_classstyle($itemclsty); }
        if ($depth > $last_depth) {
          for ($j = $last_depth; $j < $depth; $j++) {
            $out .= "\n<$list_tags[$type]";
            $stack[] = $type;
            if ($blockclsty) {
              $blockattr = $this->format_classstyle($blockclsty);
              if ($blockattr) { $out .= ' ' . $blockattr; }
            }
            $out .= ">\n<li";
            if ($itemattr) { $out .= " $itemattr"; }
            $out .= ">";
          }
        } elseif ($depth < $last_depth) {
          for ($j = $depth; $j < $last_depth; $j++) {
            if ($j == $depth) { $out .= "</li>\n"; }
            $type = array_pop($stack);
            $out .= "</$list_tags[$type]>\n</li>\n";
          }
          if ($depth) {
            $out .= '<li';
            if ($itemattr) { $out .= " $itemattr"; }
            $out .= '>';
          }
        } else {
          $out .= "</li>\n<li";
          if ($itemattr) { $out .= " $itemattr"; }
          $out .= '>';
        }
        $last_depth = $depth;
      }
      if ($item != '') { $item .= "\n"; }
      $item .= $this->format_paragraph(array('text' => $line));
    }

    if (preg_match('/\n/', $item, $matches)) {
      if ($this->options['_line_open']) {
        $item = preg_replace('/(<li[^>]*>|^)/m', '$1' . $this->options['_line_open'], $item);
        $item = preg_replace('/(\n|$)/s', $this->options['_line_close'] . '$1', $item);
      } else {
        $item = preg_replace('/(\n)/s', $this->options['_line_close'] . '$1', $item);
      }
    }
    $out .= $item;

    for ($j = 1; $j <= $last_depth; $j++) {
      if ($j == 1) { $out .= '</li>'; }
      $type = array_pop($stack);
      $out .= "\n" . '</' . $list_tags[$type] . '>' . "\n";
      if ($j != $last_depth) { $out .= '</li>'; }
    }

    return $out . "\n";
  }
function format_block($args) {
    $str = (isset($args['text']) ? $args['text'] : '');
    $inline = $args['inline'];
    $pre = (isset($args['pre']) ? $args['pre'] : '');
    $post = (isset($args['post']) ? $args['post'] : '');
    $this->_strip_borders($pre, $post);
    $filters = (preg_match('/^(\|(?:(?:[a-z0-9_\-]+)\|)+)/', $str, $matches) ? $matches[1] : '');
    if ($filters) {
      $filtreg = preg_replace('/[^A-Za-z0-9]/', '\\\\$1', $filters);
      $str = preg_replace('/^' . $filtreg . '/', '', $str, 1);
      $filters = preg_replace('/^\|/', '', $filters, 1);
      $filters = preg_replace('/\|$/', '', $filter, 1);
      $filters = preg_split('/\|/', $filters);
      $str = $this->apply_filters(array('text' => $str, 'filters' => $filters));
      $count = count($filters);
      if ($str = preg_replace('!(<p>){' . $count . '}!se', '(++$i ? "$1" : "$1")', $str) && $i) {
        $str = preg_replace('!(</p>){' . $count . '}!s', '$1', $str);
        $str = preg_replace('!(<br( /)?>){' . $count . '}!s', '$1', $str);
      }
    }
    if ($inline) {
      $str = preg_replace('/^\s*<p[^>]*>/', '', $str, 1);
      $str = preg_replace('/<\/p>\s*$/', '', $str, 1);
    }
    return $pre . $str . $post;
  }
function format_link($args) {
    $text = (isset($args['text']) ? $args['text'] : '');
    $linktext = (isset($args['linktext']) ? $args['linktext'] : '');
    $title = $args['title'];
    $url = $args['url'];
    $clsty = $args['clsty'];

    if (!$url || ($url == '')) {
      return $text;
    }
    if (isset($this->links) && isset($this->links[$url])) {
      $title = ($title ? $title : $this->links[$url]['title']);
      $url = $this->links[$url]['url'];
    }
    $linktext = preg_replace('/ +$/', '', $linktext, 1);
    $linktext = $this->format_paragraph(array('text' => $linktext));
    $url = $this->format_url(array('linktext' => $linktext, 'url' => $url));
    $tag = "<a href=\"$url\"";
    $attr = $this->format_classstyle($clsty);
    if ($attr) { $tag .= " $attr"; }
    if ($title) {
      $title = preg_replace('/^\s+/', '', $title, 1);
      if (strlen($title)) { $tag .= " title=\"$title\""; }
    }
    $tag .= ">$linktext</a>";
    return $tag;
  }
function format_url($args) {
    $url = ($args['url'] ? $args['url'] : '');
    if (preg_match('/^(mailto:)?([-\+\w]+@[-\w]+(\.\w[-\w]*)+)$/', $url, $matches)) {
      $url = 'mailto:' . $this->mail_encode($matches[2]);
    }
    if (!preg_match('!^(/|\./|\.\./|#)!', $url)) {
      if (!preg_match('!^(https?|ftp|mailto|nntp|telnet)!', $url)) { $url = "http://$url"; }
    }
    $url = preg_replace('/&(?!amp;)/', '&amp;', $url);
    $url = preg_replace('/\ /', '+', $url);
    $url = preg_replace_callback('/^((?:.+?)\?)(.+)$/', $this->_cb('$m[1] . $me->encode_url($m[2])'), $url);
    return $url;
  }
function format_span($args) {
    $text = (isset($args['text']) ? $args['text'] : '');
    $pre = (isset($args['pre']) ? $args['pre'] : '');
    $post = (isset($args['post']) ? $args['post'] : '');
    $align = $args['align'];
    $cite = (isset($args['cite']) ? $args['cite'] : '');
    $clsty = $args['clsty'];
    $this->_strip_borders($pre, $post);
    unset($class, $style);
    $tag  = "<span";
    $style = '';
    if ($align) {
      if ($self->options['css_mode']) {
        $alignment = $this->_halign($align);
        if ($alignment) { $style .= ";float:$alignment"; }
        if ($alignment) { $class .= ' ' . $this->options['css']["class_align_$alignment"]; }
      } else {
        $alignment = ($this->_halign($align) ? $this->_halign($align) : $this->_valign($align));
        if ($alignment) { $tag .= " align=\"$alignment\""; }
      }
    }
    $attr = $this->format_classstyle($clsty, $class, $style);
    if ($attr) { $tag .= " $attr"; }
    if ($cite) {
      $cite = preg_replace('/^:/', '', $cite, 1);
      $cite = $this->format_url(array('url' => $cite));
      $tag .= " cite=\"$cite\"";
    }
    return $pre . $tag . '>' . $this->format_paragraph(array('text' => $text)) . '</span>' . $post;
  }
function format_image($args) {
    $src = (isset($args['src']) ? $args['src'] : '');
    $extra = $args['extra'];
    $align = $args['align'];
    $pre = (isset($args['pre']) ? $args['pre'] : '');
    $post = (isset($args['post']) ? $args['post'] : '');
    $link = $args['url'];
    $clsty = $args['clsty'];
    $this->_strip_borders($pre, $post);
    if (strlen($src) == 0) { return $pre . '!!' . $post; }
    unset($tag);
    if (preg_match('/^xhtml2/', $this->options['flavor'])) {
      unset($type); // poor man's mime typing. need to extend this externally
      if (preg_match('/(?:\.jpeg|\.jpg)$/i', $src)) {
        $type = 'image/jpeg';
      } elseif (preg_match('/\.gif$/i', $src)) {
        $type = 'image/gif';
      } elseif (preg_match('/\.png$/i', $src)) {
        $type = 'image/png';
      } elseif (preg_match('/\.tiff$/i', $src)) {
        $type = 'image/tiff';
      }
      $tag = "<object";
      if ($type) { $tag .= " type=\"$type\""; }
      $tag .= " data=\"$src\"";
    } else {
      $tag = "<img src=\"$src\"";
    }
    unset($class, $style);
    if ($align) {
      if ($this->options['css_mode']) {
        $alignment = $this->_halign($align);
        if ($alignment) { $style .= ";float:$alignment"; }
        if ($alignment) { $class .= ' ' . $alignment; }
        $alignment = $this->_valign($align);
        if ($alignment) {
          $imgvalign = (preg_match('/(top|bottom)/', $alignment) ? 'text-' . $alignment : $alignment);
          if ($imgvalign) { $style .= ";vertical-align:$imgvalign"; }
          if ($alignment) { $class .= ' ' . $this->options['css']["class_align_$alignment"]; }
        }
      } else {
        $alignment = ($this->_halign($align) ? $this->_halign($align) : $this->_valign($align));
        if ($alignment) { $tag .= " align=\"$alignment\""; }
      }
    }
    unset($pctw, $pcth, $w, $h, $alt);
    if ($extra) {
      $alt = (preg_match('/\(([^\)]+)\)/', $extra, $matches) ? $matches[1] : '');
      $extra = preg_replace('/\([^\)]+\)/', '', $extra, 1);
      $pct = (preg_match('/(^|\s)(\d+)%(\s|$)/', $extra, $matches) ? $matches[2] : '');
      if (!$pct) {
        list($pctw, $pcth) = (preg_match('/(^|\s)(\d+)%x(\d+)%(\s|$)/', $extra, $matches) ? array($matches[2], $matches[3]) : NULL);
      } else {
        $pctw = $pcth = $pct;
      }
      if (!$pctw && !$pcth) {
        list($w,$h) = (preg_match('/(^|\s)(\d+|\*)x(\d+|\*)(\s|$)/', $extra, $matches) ? array($matches[2], $matches[3]) : NULL);
        if ($w == '*') { $w = ''; }
        if ($h == '*') { $h = ''; }
        if (!$w) {
          $w = (preg_match('/(^|[,\s])(\d+)w([\s,]|$)/', $extra, $matches) ? $matches[2] : '');
        }
        if (!$h) {
          $h = (preg_match('/(^|[,\s])(\d+)h([\s,]|$)/', $extra, $matches) ? $matches[2] : '');
        }
      }
    }
    $alt = ($alt ? $alt : '');
    if (!preg_match('/^xhtml2/', $this->options['flavor'])) {
      $tag .= ' alt="' . $this->encode_html_basic($alt) . '"';
    }
    if ($w && $h) {
      if (!preg_match('/^xhtml2/', $this->options['flavor'])) {
        $tag .= " height=\"$h\" width=\"$w\"";
      } else {
        $style .= ";height:${h}px;width:${w}px";
      }
    } else {
      list($image_w, $image_h) = $this->image_size($src);
      if (($image_w && $image_h) && ($w || $h)) {
        if ($w && !$h) {
          $h = intval($image_h * ($w / $image_w));
        } elseif ($h && !$w) {
          $w = intval($image_w * ($h / $image_h));
        }
      } else {
        $w = $image_w;
        $h = $image_h;
      }
      if ($w && $h) {
        if ($pctw || $pcth) {
          $w = intval($w * $pctw / 100);
          $h = intval($h * $pcth / 100);
        }
        if (!preg_match('/^xhtml2/', $this->options['flavor'])) {
          $tag .= " height=\"$h\" width=\"$w\"";
        } else {
          $style .= ";height:{$h}px;width:{$w}px";
        }
      }
    }
    $attr = $this->format_classstyle($clsty, $class, $style);
    if ($attr) { $tag .= " $attr"; }
    if (preg_match('/^xhtml2/', $this->options['flavor'])) {
      $tag .= '><p>' . $this->encode_html_basic($alt) . '</p></object>';
    } elseif (preg_match('/^xhtml/', $this->options['flavor'])) {
      $tag .= ' />';
    } else {
      $tag .= '>';
    }
    if ($link) {
      $link = preg_replace('/^:/', '', $link, 1);
      $link = $this->format_url(array('url' => $link));
      $tag = '<a href="' . $link . '">' . $tag . '</a>';
    }
    return $pre . $tag . $post;
  }
function format_table($args) {
    $str = (isset($args['text']) ? $args['text'] : '');

    $lines = preg_split('/\n/', $str);
    unset($rows);
    $line_count = count($lines);
    for ($i = 0; $i < $line_count; $i++) {
      if (!preg_match('/\|\s*$/', $lines[$i])) {
        if ($i + 1 < $line_count) {
          if ($i + 1 <= count($lines) - 1) { $lines[$i + 1] = $lines[$i] . "\n" . $lines[$i + 1]; }
        } else {
          $rows[] = $lines[$i];
        }
      } else {
        $rows[] = $lines[$i];
      }
    }
    unset($tid, $tpadl, $tpadr, $tlang);
    $tclass = '';
    $tstyle = '';
    $talign = '';
    if (preg_match('/^table[^\.]/', $rows[0])) {
      $row = $rows[0];
      $row = preg_replace('/^table/', '', $row, 1);
      $params = 1;
      while ($params) {
        if (preg_match('{^(' . $this->tblalignre . ')}', $row, $matches)) {
          $talign .= $matches[1];
          if ($matches[1]) { $row = substr($row, strlen($matches[1])); }
          if ($matches[1]) { continue; }
        }
        if (preg_match('{^(' . $this->clstypadre . ')}x', $row, $matches)) {
          $clsty = $matches[1];
          if ($clsty) { $row = substr($row, strlen($clsty)); }
          if (preg_match('/{([^}]+)}/', $clsty, $matches)) {
            $tstyle = $matches[1];
            $clsty = preg_replace('/{([^}]+)}/', '', $clsty, 1);
            if ($tstyle) { continue; }
          }
          if (preg_match('/\(([A-Za-z0-9_\- ]+?)(?:#(.+?))?\)/', $clsty, $matches) ||
              preg_match('/\(([A-Za-z0-9_\- ]+?)?(?:#(.+?))\)/', $clsty, $matches)) {
            if ($matches[1] || $matches[2]) {
              $tclass = $matches[1];
              $tid = $matches[2];
              continue;
            }
          }
          if (preg_match('/(\(+)/', $clsty, $matches)) { $tpadl = strlen($matches[1]); }
          if (preg_match('/(\)+)/', $clsty, $matches)) { $tpadr = strlen($matches[1]); }
          if (preg_match('/\[(.+?)\]/', $clsty, $matches)) { $tlang = $matches[1]; }
          if ($clsty) { continue; }
        }
        $params = 0;
      }
      $row = preg_replace('/\.\s+/', '', $row, 1);
      $rows[0] = $row;
    }
    $out = '';
    $cols = preg_split('/\|/', $rows[0] . ' ');
    unset($colaligns, $rowspans);
    foreach ($rows as $row) {
      $cols = preg_split('/\|/', $row . ' ');
      $colcount = count($cols) - 1;
      array_pop($cols);
      $colspan = 0;
      $row_out = '';
      unset($rowclass, $rowid, $rowalign, $rowstyle, $rowheader);
      if (!$cols[0]) { $cols[0] = ''; }
      if (preg_match('/_/', $cols[0])) {
        $cols[0] = preg_replace('/_/', '', $cols[0]);
        $rowheader = 1;
      }
      if (preg_match('/{([^}]+)}/', $cols[0], $matches)) {
        $rowstyle = $matches[1];
        $cols[0] = preg_replace('/{[^}]+}/', '', $cols[0]);
      }
      if (preg_match('/\(([^\#]+?)?(#(.+))?\)/', $cols[0], $matches)) {
        $rowclass = $matches[1];
        $rowid = $matches[3];
        $cols[0] = preg_replace('/\([^\)]+\)/', '', $cols[0]);
      }
      if (preg_match('{(' . $this->alignre . ')}', $cols[0], $matches)) { $rowalign = $matches[1]; }
      for ($c = $colcount - 1; $c > 0; $c--) {
        if ($rowspans[$c]) {
          $rowspans[$c]--;
          if ($rowspans[$c] > 1) { continue; }
        }
        unset($colclass, $colid, $header, $colparams, $colpadl, $colpadr, $collang);
        $colstyle = '';
        $colalign = $colaligns[$c];
        $col = array_pop($cols);
        $col = ($col ? $col : '');
        $attrs = '';
        if (preg_match('{^(((_|[/\\\\]\d+|' . $this->alignre . '|' . $this->clstypadre . ')+)\.\ )}x', $col, $matches)) {
          $colparams = $matches[2];
          $col = substr($col, strlen($matches[1]));
          $params = 1;
          while ($params) {
            if (preg_match('{^(_|' . $this->alignre . ')(.*)$}', $colparams, $matches)) {
              $attrs .= $matches[1];
              if ($matches[1]) { $colparams = $matches[2]; }
              if ($matches[1]) { continue; }
            }
            if (preg_match('{^(' . $this->clstypadre . ')(.*)$}x', $colparams, $matches)) {
              $clsty = $matches[1];
              if ($clsty) { $colparams = $matches[2]; }
              if (preg_match('/{([^}]+)}/', $clsty, $matches)) {
                $colstyle = $matches[1];
                $clsty = preg_replace('/{([^}]+)}/', '', $clsty, 1);
              }
              if (preg_match('/\(([A-Za-z0-9_\- ]+?)(?:#(.+?))?\)/', $clsty, $matches) ||
                  preg_match('/\(([A-Za-z0-9_\- ]+?)?(?:#(.+?))\)/', $clsty, $matches)) {
                if ($matches[1] || $matches[2]) {
                  $colclass = $matches[1];
                  $colid = $matches[2];
                  if ($colclass) {
                    $clsty = preg_replace('/\([A-Za-z0-9_\- ]+?(#.*?)?\)/', '', $clsty);
                  } elseif ($colid) {
                    $clsty = preg_replace('/\(#.+?\)/', '', $clsty);
                  }
                }
              }
              if (preg_match('/(\(+)/', $clsty, $matches)) {
                $colpadl = strlen($matches[1]);
                $clsty = preg_replace('/\(+/', '', $clsty, 1);
              }
              if (preg_match('/(\)+)/', $clsty, $matches)) {
                $colpadr = strlen($matches[1]);
                $clsty = preg_replace('/\)+/', '', $clsty, 1);
              }
              if (preg_match('/\[(.+?)\]/', $clsty, $matches)) {
                $collang = $matches[1];
                $clsty = preg_replace('/\[.+?\]/', '', $clsty, 1);
              }
              if ($clsty) { continue; }
            }
            if (preg_match('/^\\\\(\d+)/', $colparams, $matches)) {
              $colspan = $matches[1];
              $colparams = substr($colparams, strlen($matches[1]) + 1);
              if ($matches[1]) { continue; }
            }
            if (preg_match('/\/(\d+)/', $colparams, $matches)) {
              if ($matches[1]) { $rowspans[$c] = $matches[1]; }
              $colparams = substr($colparams, strlen($matches[1]) + 1);
              if ($matches[1]) { continue; }
            }
            $params = 0;
          }
        }
        if (strlen($attrs)) {
          if (preg_match('/_/', $attrs)) { $header = 1; }
          if (preg_match('{(' . $this->alignre . ')}', $attrs, $matches) && strlen($matches[1])) { $colalign = ''; }
          if (preg_match('/<>/', $attrs)) {
            $colalign .= '<>';
          } elseif (preg_match('/</', $attrs)) {
            $colalign .= '<';
          } elseif (preg_match('/=/', $attrs)) {
            $colalign = '=';
          } elseif (preg_match('/>/', $attrs)) {
            $colalign = '>';
          }
          if (preg_match('/\^/', $attrs)) {
            $colalign .= '^';
          } elseif (preg_match('/~/', $attrs)) {
            $colalign .= '~';
          } elseif (preg_match('/-/', $attrs)) {
            $colalign .= '-';
          }
        }
        if ($rowheader) { $header = 1; }
        if ($header) { $colaligns[$c] = $colalign; }
        $col = preg_replace('/^ +/', '', $col, 1); $col = preg_replace('/ +$/', '', $col, 1);
        if (strlen($col)) {
          $rowspan = ($rowspans[$c] ? $rowspans[$c] : 0);
          $col_out = '<' . ($header ? 'th' : 'td');
          if ($colalign) {
            $halign = $this->_halign($colalign);
            if ($halign) { $col_out .= " align=\"$halign\""; }
            $valign = $this->_valign($colalign);
            if ($valign) { $col_out .= " valign=\"$valign\""; }
          }
          if ($colpadl) { $colstyle .= ";padding-left:${colpadl}em"; }
          if ($colpadr) { $colstyle .= ";padding-right:${colpadr}em"; }
          if ($colclass) { $col_out .= " class=\"$colclass\""; }
          if ($colid) { $col_out .= " id=\"$colid\""; }
          if ($colstyle) { $colstyle = preg_replace('/^;/', '', $colstyle, 1); }
          if ($colstyle) { $col_out .= " style=\"$colstyle\""; }
          if ($collang) { $col_out .= " lang=\"$collang\""; }
          if ($colspan > 1) { $col_out .= " colspan=\"$colspan\""; }
          if ($rowspan > 1) { $col_out .= " rowspan=\"$rowspan\""; }
          $col_out .= '>';
          if (preg_match('/\n\n/', $col) ||
              preg_match('{^(?:' . $this->halignre . '|' . $this->clstypadre . '*)*
                            [\*\#]
                            (?:' . $this->clstypadre . '*|' . $this->halignre . ')*\ }x', $col)) {
            $col_out .= $this->process($col);
          } else {
            $col_out .= $this->format_paragraph(array('text' => $col));
          }
          $col_out .= '</' . ($header ? 'th' : 'td') . '>';
          $row_out = $col_out . $row_out;
          if ($colspan) { $colspan = 0; }
        } else {
          if ($colspan == 0) { $colspan = 1; }
          $colspan++;
        }
      }
      if ($colspan > 1) {
        $colspan--;
        $row_out = "<td"
                 . ($colspan > 1 ? " colspan=\"$colspan\"" : '')
                 . "></td>$row_out";
      }

      $out .= "<tr";
      if ($rowalign) {
        $valign = $this->_valign($rowalign);
        if ($valign) { $out .= " valign=\"$valign\""; }
      }
      if ($rowclass) { $out .= " class=\"$rowclass\""; }
      if ($rowid) { $out .= " id=\"$rowid\""; }
      if ($rowstyle) { $out .= " style=\"$rowstyle\""; }
      $out .= ">$row_out</tr>";
    }

    $table = '';
    $table .= "<table";
    if ($talign) {
      if ($this->options['css_mode']) {
        $alignment = $this->_halign($talign);
        if ($talign == '=') {
          $tstyle .= ';margin-left:auto;margin-right:auto';
        } else {
          if ($alignment) { $tstyle .= ';float:' . $alignment; }
        }
        if ($alignment) { $tclass .= ' ' . $alignment; }
      } else {
        $alignment = $this->_halign($talign);
        if ($alignment) { $table .= " align=\"$alignment\""; }
      }
    }
    if ($tpadl) { $tstyle .= ";padding-left:${tpadl}em"; }
    if ($tpadr) { $tstyle .= ";padding-right:${tpadr}em"; }
    if ($tclass) { $tclass = preg_replace('/^ /', '', $tclass, 1); }
    if ($tclass) { $table .= " class=\"$tclass\""; }
    if ($tid) { $table .= " id=\"$tid\""; }
    if ($tstyle) { $tstyle = preg_replace('/^;/', '', $tstyle, 1); }
    if ($tstyle) { $table .= " style=\"$tstyle\""; }
    if ($tlang) { $table .= " lang=\"$tlang\""; }
    if ($tclass || $tid || $tstyle) { $table .= " cellspacing=\"0\""; }
    $table .= ">$out</table>";

    if (preg_match('|<tr></tr>|', $table)) {
      return NULL;
    }

    return $table;
  }
function apply_filters($args) {
    $text = $args['text'];
    if (!$text) { return ''; }
    $list = $args['filters'];
    $filters = $this->options['filters'];
    if (!is_array($filters)) { return $text; }

    $param = $this->filter_param();
    foreach ($list as $filter) {
      if (!isset($filters[$filter])) { continue; }
      if (is_string($filters[$filter])) {
        $text = (($f = create_function('$text, $param', $filters[$filter])) ? $f($text, $param) : $text);
      }
    }
    return $text;
  }
var $Have_Entities = 1;
  function encode_html($html, $can_double_encode = FALSE) {
    if (!$html) { return ''; }
    if ($this->Have_Entities && $this->options['char_encoding']) {
      $html = htmlentities($html);
    } else {
      $html = $this->encode_html_basic($html, $can_double_encode);
    }
    return $html;
  }
  function decode_html($html) {
    $html = preg_replace('!&quot;!', '"', $html);
    $html = preg_replace('!&amp;!', '&', $html);
    $html = preg_replace('!&lt;!', '<', $html);
    $html = preg_replace('!&gt;!', '>', $html);
    return $html;
  }
  function encode_html_basic($html, $can_double_encode = FALSE) {
    if (!$html) { return ''; }
    if (!preg_match('/[^\w\s]/', $html)) { return $html; }
    if ($can_double_encode) {
      $html = preg_replace('!&!', '&amp;', $html);
    } else {

      $html = preg_replace('/&(?!#?[xX]?(?:[0-9a-fA-F]+|\w{1,8});)/', '&amp;', $html);
    }
    $html = preg_replace('!"!', '&quot;', $html);
    $html = preg_replace('!<!', '&lt;', $html);
    $html = preg_replace('!>!', '&gt;', $html);
    return $html;
  }
  function image_size($file) {
    $Have_ImageSize = function_exists('getimagesize');

    if ($Have_ImageSize) {
      if (file_exists($file)) {
        return @getimagesize($file);
      } else {
        if ($docroot = ($this->docroot() ? $this->docroot() : $_SERVER['DOCUMENT_ROOT'])) {
          $fullpath = $docroot . preg_replace('|^/*(.*)$|', '/$1', $file);
          if (file_exists($fullpath)) {
            return @getimagesize($fullpath);
          }
        }
      }
    }
    return @getimagesize($file);
  }
  function encode_url($str) {
    $str = preg_replace_callback('!([^A-Za-z0-9_\.\-\+\&=%;])!x',
                            $this->_cb('ord($m[1]) > 255 ? \'%u\' . sprintf("%04X", ord($m[1]))
                                                       : \'%\'  . sprintf("%02X", ord($m[1]))'), $str);
    return $str;
  }
  function mail_encode($addr) {
    $addr = preg_replace_callback('!([^\$])!x',
                             $this->_cb('ord($m[1]) > 255 ? \'%u\' . sprintf("%04X", ord($m[1]))
                                                        : \'%\'  . sprintf("%02X", ord($m[1]))'), $addr);
    return $addr;
  }
  function process_quotes($str) {
    return $str;
  }
  function default_macros() {

    return array(
      'c|' => '&#162;', // CENT SIGN
      '|c' => '&#162;', // CENT SIGN
      'L-' => '&#163;', // POUND SIGN
      '-L' => '&#163;', // POUND SIGN
      'Y=' => '&#165;', // YEN SIGN
      '=Y' => '&#165;', // YEN SIGN
      '(c)' => '&#169;', // COPYRIGHT SIGN
      '&lt;&lt;' => '&#171;', // LEFT-POINTING DOUBLE ANGLE QUOTATION
      '(r)' => '&#174;', // REGISTERED SIGN
      '+_' => '&#177;', // PLUS-MINUS SIGN
      '_+' => '&#177;', // PLUS-MINUS SIGN
      '&gt;&gt;' => '&#187;', // RIGHT-POINTING DOUBLE ANGLE QUOTATION
      '1/4' => '&#188;', // VULGAR FRACTION ONE QUARTER
      '1/2' => '&#189;', // VULGAR FRACTION ONE HALF
      '3/4' => '&#190;', // VULGAR FRACTION THREE QUARTERS
      'A`' => '&#192;', // LATIN CAPITAL LETTER A WITH GRAVE
      '`A' => '&#192;', // LATIN CAPITAL LETTER A WITH GRAVE
      'A\'' => '&#193;', // LATIN CAPITAL LETTER A WITH ACUTE
      '\'A' => '&#193;', // LATIN CAPITAL LETTER A WITH ACUTE
      'A^' => '&#194;', // LATIN CAPITAL LETTER A WITH CIRCUMFLEX
      '^A' => '&#194;', // LATIN CAPITAL LETTER A WITH CIRCUMFLEX
      'A~' => '&#195;', // LATIN CAPITAL LETTER A WITH TILDE
      '~A' => '&#195;', // LATIN CAPITAL LETTER A WITH TILDE
      'A"' => '&#196;', // LATIN CAPITAL LETTER A WITH DIAERESIS
      '"A' => '&#196;', // LATIN CAPITAL LETTER A WITH DIAERESIS
      'Ao' => '&#197;', // LATIN CAPITAL LETTER A WITH RING ABOVE
      'oA' => '&#197;', // LATIN CAPITAL LETTER A WITH RING ABOVE
      'AE' => '&#198;', // LATIN CAPITAL LETTER AE
      'C,' => '&#199;', // LATIN CAPITAL LETTER C WITH CEDILLA
      ',C' => '&#199;', // LATIN CAPITAL LETTER C WITH CEDILLA
      'E`' => '&#200;', // LATIN CAPITAL LETTER E WITH GRAVE
      '`E' => '&#200;', // LATIN CAPITAL LETTER E WITH GRAVE
      'E\'' => '&#201;', // LATIN CAPITAL LETTER E WITH ACUTE
      '\'E' => '&#201;', // LATIN CAPITAL LETTER E WITH ACUTE
      'E^' => '&#202;', // LATIN CAPITAL LETTER E WITH CIRCUMFLEX
      '^E' => '&#202;', // LATIN CAPITAL LETTER E WITH CIRCUMFLEX
      'E"' => '&#203;', // LATIN CAPITAL LETTER E WITH DIAERESIS
      '"E' => '&#203;', // LATIN CAPITAL LETTER E WITH DIAERESIS
      'I`' => '&#204;', // LATIN CAPITAL LETTER I WITH GRAVE
      '`I' => '&#204;', // LATIN CAPITAL LETTER I WITH GRAVE
      'I\'' => '&#205;', // LATIN CAPITAL LETTER I WITH ACUTE
      '\'I' => '&#205;', // LATIN CAPITAL LETTER I WITH ACUTE
      'I^' => '&#206;', // LATIN CAPITAL LETTER I WITH CIRCUMFLEX
      '^I' => '&#206;', // LATIN CAPITAL LETTER I WITH CIRCUMFLEX
      'I"' => '&#207;', // LATIN CAPITAL LETTER I WITH DIAERESIS
      '"I' => '&#207;', // LATIN CAPITAL LETTER I WITH DIAERESIS
      'D-' => '&#208;', // LATIN CAPITAL LETTER ETH
      '-D' => '&#208;', // LATIN CAPITAL LETTER ETH
      'N~' => '&#209;', // LATIN CAPITAL LETTER N WITH TILDE
      '~N' => '&#209;', // LATIN CAPITAL LETTER N WITH TILDE
      'O`' => '&#210;', // LATIN CAPITAL LETTER O WITH GRAVE
      '`O' => '&#210;', // LATIN CAPITAL LETTER O WITH GRAVE
      'O\'' => '&#211;', // LATIN CAPITAL LETTER O WITH ACUTE
      '\'O' => '&#211;', // LATIN CAPITAL LETTER O WITH ACUTE
      'O^' => '&#212;', // LATIN CAPITAL LETTER O WITH CIRCUMFLEX
      '^O' => '&#212;', // LATIN CAPITAL LETTER O WITH CIRCUMFLEX
      'O~' => '&#213;', // LATIN CAPITAL LETTER O WITH TILDE
      '~O' => '&#213;', // LATIN CAPITAL LETTER O WITH TILDE
      'O"' => '&#214;', // LATIN CAPITAL LETTER O WITH DIAERESIS
      '"O' => '&#214;', // LATIN CAPITAL LETTER O WITH DIAERESIS
      'O/' => '&#216;', // LATIN CAPITAL LETTER O WITH STROKE
      '/O' => '&#216;', // LATIN CAPITAL LETTER O WITH STROKE
      'U`' =>  '&#217;', // LATIN CAPITAL LETTER U WITH GRAVE
      '`U' =>  '&#217;', // LATIN CAPITAL LETTER U WITH GRAVE
      'U\'' => '&#218;', // LATIN CAPITAL LETTER U WITH ACUTE
      '\'U' => '&#218;', // LATIN CAPITAL LETTER U WITH ACUTE
      'U^' => '&#219;', // LATIN CAPITAL LETTER U WITH CIRCUMFLEX
      '^U' => '&#219;', // LATIN CAPITAL LETTER U WITH CIRCUMFLEX
      'U"' => '&#220;', // LATIN CAPITAL LETTER U WITH DIAERESIS
      '"U' => '&#220;', // LATIN CAPITAL LETTER U WITH DIAERESIS
      'Y\'' => '&#221;', // LATIN CAPITAL LETTER Y WITH ACUTE
      '\'Y' => '&#221;', // LATIN CAPITAL LETTER Y WITH ACUTE
      'a`' => '&#224;', // LATIN SMALL LETTER A WITH GRAVE
      '`a' => '&#224;', // LATIN SMALL LETTER A WITH GRAVE
      'a\'' => '&#225;', // LATIN SMALL LETTER A WITH ACUTE
      '\'a' => '&#225;', // LATIN SMALL LETTER A WITH ACUTE
      'a^' => '&#226;', // LATIN SMALL LETTER A WITH CIRCUMFLEX
      '^a' => '&#226;', // LATIN SMALL LETTER A WITH CIRCUMFLEX
      'a~' => '&#227;', // LATIN SMALL LETTER A WITH TILDE
      '~a' => '&#227;', // LATIN SMALL LETTER A WITH TILDE
      'a"' => '&#228;', // LATIN SMALL LETTER A WITH DIAERESIS
      '"a' => '&#228;', // LATIN SMALL LETTER A WITH DIAERESIS
      'ao' => '&#229;', // LATIN SMALL LETTER A WITH RING ABOVE
      'oa' => '&#229;', // LATIN SMALL LETTER A WITH RING ABOVE
      'ae' => '&#230;', // LATIN SMALL LETTER AE
      'c,' => '&#231;', // LATIN SMALL LETTER C WITH CEDILLA
      ',c' => '&#231;', // LATIN SMALL LETTER C WITH CEDILLA
      'e`' => '&#232;', // LATIN SMALL LETTER E WITH GRAVE
      '`e' => '&#232;', // LATIN SMALL LETTER E WITH GRAVE
      'e\'' => '&#233;', // LATIN SMALL LETTER E WITH ACUTE
      '\'e' => '&#233;', // LATIN SMALL LETTER E WITH ACUTE
      'e^' => '&#234;', // LATIN SMALL LETTER E WITH CIRCUMFLEX
      '^e' => '&#234;', // LATIN SMALL LETTER E WITH CIRCUMFLEX
      'e"' => '&#235;', // LATIN SMALL LETTER E WITH DIAERESIS
      '"e' => '&#235;', // LATIN SMALL LETTER E WITH DIAERESIS
      'i`' => '&#236;', // LATIN SMALL LETTER I WITH GRAVE
      '`i' => '&#236;', // LATIN SMALL LETTER I WITH GRAVE
      'i\'' => '&#237;', // LATIN SMALL LETTER I WITH ACUTE
      '\'i' => '&#237;', // LATIN SMALL LETTER I WITH ACUTE
      'i^' => '&#238;', // LATIN SMALL LETTER I WITH CIRCUMFLEX
      '^i' => '&#238;', // LATIN SMALL LETTER I WITH CIRCUMFLEX
      'i"' => '&#239;', // LATIN SMALL LETTER I WITH DIAERESIS
      '"i' => '&#239;', // LATIN SMALL LETTER I WITH DIAERESIS
      'n~' => '&#241;', // LATIN SMALL LETTER N WITH TILDE
      '~n' => '&#241;', // LATIN SMALL LETTER N WITH TILDE
      'o`' => '&#242;', // LATIN SMALL LETTER O WITH GRAVE
      '`o' => '&#242;', // LATIN SMALL LETTER O WITH GRAVE
      'o\'' => '&#243;', // LATIN SMALL LETTER O WITH ACUTE
      '\'o' => '&#243;', // LATIN SMALL LETTER O WITH ACUTE
      'o^' => '&#244;', // LATIN SMALL LETTER O WITH CIRCUMFLEX
      '^o' => '&#244;', // LATIN SMALL LETTER O WITH CIRCUMFLEX
      'o~' => '&#245;', // LATIN SMALL LETTER O WITH TILDE
      '~o' => '&#245;', // LATIN SMALL LETTER O WITH TILDE
      'o"' => '&#246;', // LATIN SMALL LETTER O WITH DIAERESIS
      '"o' => '&#246;', // LATIN SMALL LETTER O WITH DIAERESIS
      ':-' => '&#247;', // DIVISION SIGN
      '-:' => '&#247;', // DIVISION SIGN
      'o/' => '&#248;', // LATIN SMALL LETTER O WITH STROKE
      '/o' => '&#248;', // LATIN SMALL LETTER O WITH STROKE
      'u`' => '&#249;', // LATIN SMALL LETTER U WITH GRAVE
      '`u' => '&#249;', // LATIN SMALL LETTER U WITH GRAVE
      'u\'' => '&#250;', // LATIN SMALL LETTER U WITH ACUTE
      '\'u' => '&#250;', // LATIN SMALL LETTER U WITH ACUTE
      'u^' => '&#251;', // LATIN SMALL LETTER U WITH CIRCUMFLEX
      '^u' => '&#251;', // LATIN SMALL LETTER U WITH CIRCUMFLEX
      'u"' => '&#252;', // LATIN SMALL LETTER U WITH DIAERESIS
      '"u' => '&#252;', // LATIN SMALL LETTER U WITH DIAERESIS
      'y\'' => '&#253;', // LATIN SMALL LETTER Y WITH ACUTE
      '\'y' => '&#253;', // LATIN SMALL LETTER Y WITH ACUTE
      'y"' => '&#255;', // LATIN SMALL LETTER Y WITH DIAERESIS
      '"y' => '&#255;', // LATIN SMALL LETTER Y WITH DIAERESIS
      'OE' => '&#338;', // LATIN CAPITAL LIGATURE OE
      'oe' => '&#339;', // LATIN SMALL LIGATURE OE
      '*' => '&#8226;', // BULLET
      'Fr' => '&#8355;', // FRENCH FRANC SIGN
      'L=' => '&#8356;', // LIRA SIGN
      '=L' => '&#8356;', // LIRA SIGN
      'Rs' => '&#8360;', // RUPEE SIGN
      'C=' => '&#8364;', // EURO SIGN
      '=C' => '&#8364;', // EURO SIGN
      'tm' => '&#8482;', // TRADE MARK SIGN
      '&lt;-' => '&#8592;', // LEFTWARDS ARROW
      '-&gt;' => '&#8594;', // RIGHTWARDS ARROW
      '&lt;=' => '&#8656;', // LEFTWARDS DOUBLE ARROW
      '=&gt;' => '&#8658;', // RIGHTWARDS DOUBLE ARROW
      '=/' => '&#8800;', // NOT EQUAL TO
      '/=' => '&#8800;', // NOT EQUAL TO
      '&lt;_' => '&#8804;', // LESS-THAN OR EQUAL TO
      '_&lt;' => '&#8804;', // LESS-THAN OR EQUAL TO
      '&gt;_' => '&#8805;', // GREATER-THAN OR EQUAL TO
      '_&gt;' => '&#8805;', // GREATER-THAN OR EQUAL TO
      ':(' => '&#9785;', // WHITE FROWNING FACE
      ':)' => '&#9786;', // WHITE SMILING FACE
      'spade' => '&#9824;', // BLACK SPADE SUIT
      'club' => '&#9827;', // BLACK CLUB SUIT
      'heart' => '&#9829;', // BLACK HEART SUIT
      'diamond' => '&#9830;', // BLACK DIAMOND SUIT
    );
  }
  function _css_defaults() {
    $css_defaults = array(
      'class_align_right' => 'right',
      'class_align_left' => 'left',
      'class_align_center' => 'center',
      'class_align_top' => 'top',
      'class_align_bottom' => 'bottom',
      'class_align_middle' => 'middle',
      'class_align_justify' => 'justify',
      'class_caps' => 'caps',
      'class_footnote' => 'footnote',
      'id_footnote_prefix' => 'fn',
    );
    $this->css($css_defaults);
  }
  function _halign($align) {
    if (preg_match('/<>/', $align)) {
      return 'justify';
    } elseif (preg_match('/</', $align)) {
      return 'left';
    } elseif (preg_match('/>/', $align)) {
      return 'right';
    } elseif (preg_match('/=/', $align)) {
      return 'center';
    }
    return '';
  }

  function _valign($align) {
    if (preg_match('/\^/', $align)) {
      return 'top';
    } elseif (preg_match('/~/', $align)) {
      return 'bottom';
    } elseif (preg_match('/-/', $align)) {
      return 'middle';
    }
    return '';
  }
  function _imgalign($align) {
    $align = preg_replace('/(<>|=)/', '', $align);
    return ($this->_valign($align) ? $this->_valign($align) : $this->_halign($align));
  }
  function _strip_borders(&$pre, &$post) {
    if ($post && $pre && preg_match('/[{[]/', ($open = substr($pre, 0, 1)))) {
      $close = substr($post, 0, 1);
      if ((($open == '{') && ($close == '}')) ||
          (($open == '[') && ($close == ']'))) {
        $pre = substr($pre, 1);
        $post = substr($post, 1);
      } else {
        if (!preg_match('/[}\]]/', $close)) { $close = substr($post, -1, 1); }
        if ((($open == '{') && ($close == '}')) ||
            (($open == '[') && ($close == ']'))) {
          $pre = substr($pre, 1);
          $post = substr($post, 0, strlen($post) - 1);
        }
      }
    }
  }
  function _repl(&$array, $str) {
    $array[] = $str;
    return '<textile#' . count($array) . '>';
  }
  function _tokenize($str) {
    $pos = 0;
    $len = strlen($str);
    unset($tokens);

    $depth = 6;
    $nested_tags = substr(str_repeat('(?:</?[A-Za-z0-9:]+ \s? (?:[^<>]|', $depth), 0, -1)
      . str_repeat(')*>)', $depth);
    $match = '(?s: <! ( -- .*? -- \s* )+ > )|  # comment
              (?s: <\? .*? \?> )|              # processing instruction
              (?s: <% .*? %> )|                # ASP-like
              (?:' . $nested_tags . ')|
              (?:' . $this->codere . ')';     // nested tags

    while (preg_match('{(' . $match . ')}x', substr($str, $pos), $matches, PREG_OFFSET_CAPTURE)) {
      $whole_tag = $matches[1][0];
      $sec_start = $pos + $matches[1][1] + strlen($whole_tag);
      $tag_start = $sec_start - strlen($whole_tag);
      if ($pos < $tag_start) {
        $tokens[] = array('text', substr($str, $pos, $tag_start - $pos));
      }
      if (preg_match('/^[[{]?@/', $whole_tag)) {
        $tokens[] = array('text', $whole_tag);
      } else {
        $whole_tag = preg_replace('/\n/', "\001", $whole_tag);
        $tokens[] = array('tag', $whole_tag);
      }
      $pos = $sec_start;
    }
    if ($pos < $len) { $tokens[] = array('text', substr($str, $pos, $len - $pos)); }
    return $tokens;
  }
  function version() {
    
    return array("text" => "2.0.8", "build" => 2005032100);
  }
  function _cb($function) {
    $current =& Textile::_current_store($this);
    return create_function('$m', '$me =& Textile::_current(); return ' . $function . ';');
  }
  function &_current_store(&$new) {
   static $current = array();

   if ($new != NULL) {
     $current = array(&$new);
   }

   return $current;
 }
  function &_current() {
   $current =& Textile::_current_store($null = NULL);
   return $current[0];
 }
}
class MTLikeTextile extends Textile {
  function MTLikeTextile($options = array()) {
    parent::Textile($options);
  }
  function process_quotes($str) {
    if (!$this->options['do_quotes'] || !function_exists('SmartyPants')) {
      return $str;
    }

    return SmartyPants($str, $this->options['smarty_mode']);
  }
  function format_url($args) {
    $url = ($args['url'] ? $args['url'] : '');

    if (preg_match('/^(imdb|google|dict|amazon)(:(.+))?$/x', $url, $matches)) {
      $term = $matches[3];
      $term = ($term ? $term : strip_tags($args['linktext']));

      switch ($matches[1]) {
        case 'imdb':
          $args['url'] = 'http://www.imdb.com/Find?for=' . $term;
          break;

        case 'google':
          $args['url'] = 'http://www.google.com/search?q=' . $term;
          break;

        case 'dict':
          $args['url'] = 'http://www.dictionary.com/search?q=' . $term;
          break;

        case 'amazon':
          $args['url'] = 'http://www.amazon.com/exec/obidos/external-search?index=blended&keyword=' . $term;
          break;
      }
    }

    return parent::format_url($args);
  }
}

/**
 * @section license LICENSE
 *
 * Text::Textile is licensed under the same terms as Perl
 * itself. Textile.php is licensed under the terms of the GNU General
 * Public License.
 *
 * @section authorandcopyright AUTHOR & COPYRIGHT
 *
 * Text::Textile was written by Brad Choate, \<brad at bradchoate dot com\>.
 * It is an adaptation of Textile, developed by Dean Allen of Textism.com.
 *
 * Textile.php is a PHP port of Brad Choate's Text::Textile
 * (Textile.pm) Perl module.
 *
 * Textile.php was ported by Jim Riggs \<textile at jimandlissa dot
 * com\>. Great care has been taken to leave the Perl code in much the
 * same form as Textile.pm. While changes were required due to
 * syntactical differences between Perl and PHP, much of the code was
 * left intact (even if alternative syntax or code optimizations could
 * have been made in PHP), even to the point where one can compare
 * functions/subroutines side by side between the two implementations.
 * This has been done to ensure compatibility, reduce the possibility
 * of introducing errors, and simplify maintainance as one version or
 * the other is updated.
 *
 * @author Jim Riggs \<textile at jimandlissa dot com\>
 * @author Brad Choate \<brad at bradchoate dot com\>
 * @copyright Copyright &copy; 2004 Jim Riggs and Brad Choate
 * @version @(#) $Id: Textile.php,v 1.5 2005/03/21 15:33:01 jhriggs Exp $
 */
?>
